#ifndef BLE_SERIAL_HPP
#define BLE_SERIAL_HPP
#include "BluetoothSerial.h"
#include "../storage/vfs.hpp"
#include "../motorcontrol.hpp"
#include "../motorlogic/actions.hpp"


void bluetooth_callback(esp_spp_cb_event_t event, esp_spp_cb_param_t *param);

class SerialBluetooth{
    BluetoothSerial* bs;
    MotorControl* mc;
    void _send_pending_stuff_value_from_nvs(std::string name);
    void put_on_action_queue(Action* action);
public:
    VFS* vfs;
    SerialBluetooth(VFS* vfs, MotorControl* mc);
    void _send_pending_stuff();
    void _on_incoming_message(String*);
    void mainloop();
    void send(char);
    void send(char*);
    void send(const char*);
    void send(int8_t*);
    void send(uint8_t*);
    void send(std::string);
    void send(String);
};

#endif
