#ifndef SHORTHANDS_GPIO
#define SHORTHANDS_GPIO

extern "C" {
    void config_output_gpio(int pin);
    void config_input_gpio(int pin);
    bool read_gpio_pin(int pin);
    void write_gpio_pin(int pin, bool value);
}

class GPIOPin {
    bool bound = false;
    bool compliment;
protected:
    void set_bound();
    bool apply_compliment_if_enabled(bool value);
    int pin;
public:
    GPIOPin(int pin, bool compliment);
    int get_pin();
    void ensure_bound();
    virtual void bind() = 0;
};

class GPIOInputPin : GPIOPin {
public:
    GPIOInputPin(int pin, bool compliment): GPIOPin(pin, compliment) {};
    void bind();
    bool read();
};

class GPIOOutputPin : GPIOPin {
    bool last_written = false;
public:
    GPIOOutputPin(int pin, bool compliment): GPIOPin(pin, compliment) {};
    void bind();
    void write(bool value);
    void flip();
    bool get_last_written();
};

#endif
