#ifndef MOTORLOGIC_ACTIONS_HPP
#define MOTORLOGIC_ACTIONS_HPP

#include <functional>
#include "motorlogic.hpp"

class Action {
public:
    Action();
    virtual ~Action();
    virtual void do_action(MotorControl*&, Coreographer*&, int&, std::function<void()>&) = 0;
};

class ActionConfigReload: public Action {
public:
    ActionConfigReload();
    ~ActionConfigReload();
    void do_action(MotorControl*&, Coreographer*&, int&, std::function<void()>&);
};

class ActionChangeRhythm: public Action{
    int new_rhythm;
public:
    ActionChangeRhythm(int);
    ~ActionChangeRhythm();
    void do_action(MotorControl*&, Coreographer*&, int&, std::function<void()>&);
};

class ActionSetCoreographer: public Action{
    Coreographer* new_coreographer;
public:
    ActionSetCoreographer(Coreographer*);
    ~ActionSetCoreographer();
    void do_action(MotorControl*&, Coreographer*&, int&, std::function<void()>&);
};

class ActionDisengage: public Action{
public:
    ActionDisengage();
    ~ActionDisengage();
    void do_action(MotorControl*&, Coreographer*&, int&, std::function<void()>&);
};

class ActionReengage: public Action{
public:
    ActionReengage();
    ~ActionReengage();
    void do_action(MotorControl*&, Coreographer*&, int&, std::function<void()>&);
};

#endif