#ifndef PINS_HPP
#define PINS_HPP

#define PIN_NOT_CONNECTED -1

#define PIN_COMPLIMENT 1
#define PIN_NORMAL 0

#define SERVO_L_FULL_STEPS_PER_REVOLUTION 200
#define SERVO_R_FULL_STEPS_PER_REVOLUTION 200

#define PIN_SERVO_L_STEP_DEFAULT PIN_NORMAL
#define PIN_SERVO_R_STEP_DEFAULT PIN_NORMAL
#define PIN_SERVO_L_ENABLE_DEFAULT PIN_COMPLIMENT
#define PIN_SERVO_R_ENABLE_DEFAULT PIN_COMPLIMENT
#define PIN_SERVO_L_MICROSTEP_DEFAULT PIN_NORMAL
#define PIN_SERVO_R_MICROSTEP_DEFAULT PIN_NORMAL

/* Drivers:
     See "steppers/driver.cpp" for reference */
#define PIN_SERVO_L_DRIVER 0
#define PIN_SERVO_R_DRIVER 0

#define PIN_SERVO_L_ENABLE 19
#define PIN_SERVO_R_ENABLE 25
#define PIN_SERVO_L_STEP 32
#define PIN_SERVO_R_STEP 12
#define PIN_SERVO_L_DIRECTION 33
#define PIN_SERVO_R_DIRECTION 13
// 6 pins OUT

#define PIN_SERVO_L_MICROSTEP_1 23
#define PIN_SERVO_R_MICROSTEP_1 26
#define PIN_SERVO_L_MICROSTEP_2 21
#define PIN_SERVO_R_MICROSTEP_2 27
#define PIN_SERVO_L_MICROSTEP_3 22
#define PIN_SERVO_R_MICROSTEP_3 14
// 6 pins OUT

#define PIN_SERVO_POS_L_T 36
#define PIN_SERVO_POS_L_B 39
#define PIN_SERVO_POS_R_T 34
#define PIN_SERVO_POS_R_B 35
// 4 pins IN

#define PIN_BOOT_RESET 18
// 1 pin IN

#define PIN_LED1_R 0
#define PIN_LED1_G 2
#define PIN_LED1_B 15
// 3 pins OUT

#define PIN_LED2_R 4
#define PIN_LED2_G 16
#define PIN_LED2_B 17
// 3 pins OUT

#endif
