#ifndef RECOVERY_BOOTSEQUENCE_HPP
#define RECOVERY_BOOTSEQUENCE_HPP

#include <string>
#include <unistd.h>
#include "nvs.h"
#include "nvs_flash.h"
#include "esp_spiffs.h"
#include "esp_system.h"
#include "altbootpin.hpp"
#include "../storage/vfs.hpp"
#include "../led.hpp"

class BootSequence {
    BootPin* bootpin;
    LED* led;
    int pending_action = 0;
public:
    BootSequence(LED* led);
    void choose_from_pin();
    void choose_from_storage(VFS* vfs);
    void remove_from_storage(VFS* vfs);
    bool has_pending_action();
    void do_action(VFS* vfs);
    void reboot();
};

#endif
