#include "driver.hpp"

std::map<int, int>* steppings_for(int driver){
    auto* mp = new std::map<int, int>();
    if(driver==0){ // Generic controller without microstepping support
        mp->insert(std::make_pair(1,  0));
        mp->insert(std::make_pair(0,  3));
        mp->insert(std::make_pair(-1, 1));
    }else if(driver==1){ // DRV8825
        // https://www.pololu.com/file/0J590/drv8825.pdf#page=13
        mp->insert(std::make_pair(32, 0b000));
        mp->insert(std::make_pair(16, 0b001));
        mp->insert(std::make_pair(8,  0b010));
        mp->insert(std::make_pair(4,  0b011));
        mp->insert(std::make_pair(2,  0b100));
        mp->insert(std::make_pair(1,  0b101));
        mp->insert(std::make_pair(0,  3));
        mp->insert(std::make_pair(-1, 32));
    }else if(driver==0){ //A3967
        // http://www.schmalzhaus.com/EasyDriver/index.html#Q12
        mp->insert(std::make_pair(8,  0b00));
        mp->insert(std::make_pair(4,  0b01));
        mp->insert(std::make_pair(2,  0b10));
        mp->insert(std::make_pair(1,  0b11));
        mp->insert(std::make_pair(0,  2));
        mp->insert(std::make_pair(-1, 8));
    }
    return mp;
}
