#ifndef STEPPERMOTORPINS_HPP
#define STEPPERMOTORPINS_HPP
#include <stdint.h>
#include <map>

struct StepperMotorPins {
    int8_t microstep_level;
    int8_t microstep[3];
    int8_t enable;
    int8_t step;
    int8_t direction;
    bool microstep_compliment;
    bool enable_compliment;
    bool step_compliment;
    std::map<int, int>* driver_steppings;
    
    StepperMotorPins(
        int8_t ml,
        int8_t ms1,
        int8_t ms2,
        int8_t ms3,
        int8_t en,
        int8_t st,
        int8_t dir,
        bool msc,
        bool enc,
        bool stc,
        std::map<int, int>* drvstps
    );
};

#endif
